%=============================================================================
%
% ORTHOGONAL wavelet transform 
% demo program using the "mdwt" and "midwt" functions of the RICE wavelet toolbox
%
% Aleksandra Pizurica, TELIN/RUG, Feb. 2001.
%=============================================================================

clear all;
close all;

InputType=0;
while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
     InputType=input('\nReference image format:\n1. "*.tif"\n2. "*.sg2"\n3. "*.mat"\n4. "*.bin"\n>>  ');
end
imload;
X=SCAN;
clear SCAN;
[M,N]=size(X);



% Choose a wavelet
 wtypeN=0;
  while((wtypeN~=1) & (wtypeN~=2) & (wtypeN~=3) & (wtypeN~=4))
    wtypeN=input('select a wavelet: 1. (db2), 2. (db4),  3. (db8), 4. (sym2), 5. (sym4) or 6. (sym8): ' );
 end
 
 if(wtypeN==1)
    wtype='db2'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db2');
    h=LO_R;  
 elseif(wtypeN==2)
    wtype='db4'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db4');
    h=LO_R;
 elseif(wtypeN==3)
    wtype='db8'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db8');
    h=LO_R;
 elseif(wtypeN==4)
    wtype='sym2'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym2');
    h=LO_R;
 elseif(wtypeN==5)
    wtype='sym4'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym4');
    h=LO_R;
 elseif(wtypeN==6)
    wtype='sym8'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym8');
    h=LO_R;
 end
 

 L=5;
 [y,L] = mdwt(X,h,L);
 
 
  HH1 = y(N/2+1:N,N/2+1:N);
  HL1 = y(1:N/2,N/2+1:N); 
  LH1 = y(N/2+1:N,1:N/2); 
  
  HH2 = y(N/4+1:N/2,N/4+1:N/2);
  HL2 = y(1:N/4,N/4+1:N/2); 
  LH2 = y(N/4+1:N/2,1:N/4); 
  
  HH3 = y(N/8+1:N/4,N/8+1:N/4);
  HL3 = y(1:N/8,N/8+1:N/4); 
  LH3 = y(N/8+1:N/4,1:N/8); 
  
  HH4 = y(N/16+1:N/8,N/16+1:N/8);
  HL4 = y(1:N/16,N/16+1:N/8); 
  LH4 = y(N/16+1:N/8,1:N/16); 
  
  HH5 = y(N/32+1:N/16,N/32+1:N/16);
  HL5 = y(1:N/32,N/32+1:N/16); 
  LH5 = y(N/32+1:N/16,1:N/32); 

  
  %---------------------------------------
  % Display subbands
  
  figure('units','normalized','position',[0.36 0.1 0.5 0.7]);

  subplot(3,3,1),imagesc(HL1);
  axis off;
  title('HL1');
  subplot(3,3,2),imagesc(LH1);
  axis off;
  title('LH1');
  subplot(3,3,3),imagesc(HH1);
  axis off;
  title('HH1');
  subplot(3,3,4),imagesc(HL2);
  axis off;
  title('HL2');
  subplot(3,3,5),imagesc(LH2);
  axis off;
  title('LH2');
  subplot(3,3,6),imagesc(HH2);
  axis off;
  title('HH2');
  subplot(3,3,7),imagesc(HL3);
  axis off;
  title('HL3');
  subplot(3,3,8),imagesc(LH3);
  axis off;
  title('LH3');
  subplot(3,3,9),imagesc(HH3);
  axis off;
  title('HH3');
  colormap(gray);
  



% Reconstruction

yp=y;

 yp(N/2+1:N,N/2+1:N)=HH1;
 yp(1:N/2,N/2+1:N)=HL1; 
 yp(N/2+1:N,1:N/2)=LH1; 
  
 yp(N/4+1:N/2,N/4+1:N/2)=HH2;
 yp(1:N/4,N/4+1:N/2)=HL2; 
 yp(N/4+1:N/2,1:N/4)=LH2; 
  
 yp(N/8+1:N/4,N/8+1:N/4)=HH3;
 yp(1:N/8,N/8+1:N/4)=HL3; 
 yp(N/8+1:N/4,1:N/8)=LH3; 
  
 yp(N/16+1:N/8,N/16+1:N/8)=HH4;
 yp(1:N/16,N/16+1:N/8)=HL4; 
 yp(N/16+1:N/8,1:N/16)=LH4; 
 
 y(N/32+1:N/16,N/32+1:N/16)=HH5;
 y(1:N/32,N/32+1:N/16)=HL5; 
 y(N/32+1:N/16,1:N/32)=LH5; 


[Xrec,L] = midwt(yp,h,L);

figure('units','normalized','position',[0.01 0.1 0.35 0.7]);
subplot(2,1,1);
imagesc(X);
colormap(gray);
title('Input image');
subplot(2,1,2);
imagesc(Xrec);
colormap(gray);
title('Reconstructed image');
   
   
