%=============================================================================
%
% ORTHOGONAL wavelet transform 
% demo program using the "mdwt" and "midwt" functions of the RICE wavelet toolbox
%
% Aleksandra Pizurica, TELIN/RUG, Feb. 2001.
%=============================================================================

clear all;
close all;

InputType=0;
while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
     InputType=input('\nReference image format:\n1. "*.tif"\n2. "*.sg2"\n3. "*.mat"\n4. "*.bin"\n>>  ');
end
imload;
X=SCAN;
clear SCAN;
[M,N]=size(X);



% Choose a wavelet
 wtypeN=0;
  while((wtypeN~=1) & (wtypeN~=2) & (wtypeN~=3) & (wtypeN~=4))
    wtypeN=input('select a wavelet: 1. (db2), 2. (db4),  3. (db8), 4. (sym2), 5. (sym4) or 6. (sym8): ' );
 end
 
 if(wtypeN==1)
    wtype='db2'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db2');
    h=LO_R;  
 elseif(wtypeN==2)
    wtype='db4'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db4');
    h=LO_R;
 elseif(wtypeN==3)
    wtype='db8'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('db8');
    h=LO_R;
 elseif(wtypeN==4)
    wtype='sym2'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym2');
    h=LO_R;
 elseif(wtypeN==5)
    wtype='sym4'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym4');
    h=LO_R;
 elseif(wtypeN==6)
    wtype='sym8'
    [LO_D,HI_D,LO_R,HI_R] = wfilters('sym8');
    h=LO_R;
 end
 

 L=4;
 [yl,yh,L] = mrdwt(X,h,L);
 
 LH1 = yh(:,1:N); 
 HL1 = yh(:,N+1:2*N); 
 HH1 = yh(:,2*N+1:3*N);
 
 LH2 = yh(:,3*N+1:4*N); 
 HL2 = yh(:,4*N+1:5*N); 
 HH2 = yh(:,5*N+1:6*N);
 
 LH3 = yh(:,6*N+1:7*N); 
 HL3 = yh(:,7*N+1:8*N); 
 HH3 = yh(:,8*N+1:9*N);
 
 LH4 = yh(:,9*N+1:10*N); 
 HL4 = yh(:,10*N+1:11*N); 
 HH4 = yh(:,11*N+1:12*N);

  
  %---------------------------------------
  % Display subbands
  
  figure('units','normalized','position',[0.36 0.1 0.5 0.7]);

  subplot(3,3,1),imagesc(HL1);
  axis off;
  title('HL1');
  subplot(3,3,2),imagesc(LH1);
  axis off;
  title('LH1');
  subplot(3,3,3),imagesc(HH1);
  axis off;
  title('HH1');
  subplot(3,3,4),imagesc(HL2);
  axis off;
  title('HL2');
  subplot(3,3,5),imagesc(LH2);
  axis off;
  title('LH2');
  subplot(3,3,6),imagesc(HH2);
  axis off;
  title('HH2');
  subplot(3,3,7),imagesc(HL3);
  axis off;
  title('HL3');
  subplot(3,3,8),imagesc(LH3);
  axis off;
  title('LH3');
  subplot(3,3,9),imagesc(HH3);
  axis off;
  title('HH3');
  colormap(gray);
  



% Reconstruction

 yhp=yh;

 yhp(:,1:N)=LH1; 
 yhp(:,N+1:2*N)=HL1; 
 yhp(:,2*N+1:3*N)=HH1;
 
 yhp(:,3*N+1:4*N)=LH2; 
 yhp(:,4*N+1:5*N)=HL2; 
 yhp(:,5*N+1:6*N)=HH2;
 
 yhp(:,6*N+1:7*N)=LH3; 
 yhp(:,7*N+1:8*N)=HL3; 
 yhp(:,8*N+1:9*N)=HH3;
 
 yhp(:,9*N+1:10*N)=LH4; 
 yhp(:,10*N+1:11*N)=HL4; 
 yhp(:,11*N+1:12*N)=HH4;


[Xrec,L] = mirdwt(yl,yhp,h,L);

figure('units','normalized','position',[0.01 0.1 0.35 0.7]);
subplot(2,1,1);
imagesc(X);
colormap(gray);
title('Input image');
subplot(2,1,2);
imagesc(Xrec);
colormap(gray);
title('Reconstructed image');
   
   
