%=======================================================================
%
% Demo program for the wavelet decomposition and reconstruction
% of an image, using quadratic spline wavelets from Mallat&Zhong'92
%
% Author: Aleksandra Pizurica TELIN/RUG jan. 1998.
%========================================================================



%clear all;
%close all;

global InputType SCAN filename;

LogTransf=''; 
InputType=0;
 
while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
   InputType=input('\nInput image format:\n1. "*.tif"\n2. "*.bmp"\n3. "*.mat"\n4. "*.bin"\n>>  ');
end
imload;
X=SCAN;
[M,N]=size(X);


%Decomposition
  
  [A1,Dx1,Dy1]=wt2_mz(X,0);   
  [A2,Dx2,Dy2]=wt2_mz(A1,1);   
  [A3,Dx3,Dy3]=wt2_mz(A2,2);  
  [A4,Dx4,Dy4]=wt2_mz(A3,3); 
  [A5,Dx5,Dy5]=wt2_mz(A4,4); 
  

figure

subplot(3,3,1),imagesc(A1),axis off,title('A1');
subplot(3,3,2),imagesc(Dx1),axis off,title('Dx1');
subplot(3,3,3),imagesc(Dy1),axis off,title('Dy1');
subplot(3,3,4),imagesc(A2),axis off,title('A2')
subplot(3,3,5),imagesc(Dx2),axis off,title('Dx2')
subplot(3,3,6),imagesc(Dy2),axis off,title('Dy2');
subplot(3,3,7),imagesc(A3),axis off,title('A3');
subplot(3,3,8),imagesc(Dx3),axis off,title('Dx3');
subplot(3,3,9),imagesc(Dy3),axis off,title('Dy3');




%Reconstruction

 A2r=iwt2_mz(A3,Dx3,Dy3,2);
 A1r=iwt2_mz(A2r,Dx2,Dy2,1);
 A0r=iwt2_mz(A1r,Dx1,Dy1,0);
 
 colormap(gray);
 
 A0r=normalize(A0r);
 
 figure
 subplot(2,1,1),imagesc(X);
 title('Original image');
 subplot(2,1,2),imagesc(A0r);
 title('Reconstructed image');
 
 colormap(gray);



